cimport propagate_puff as pp
from cython.parallel cimport *
cimport numpy
from puff_tools cimport Puff
cimport cython

# Workaround: Cython nepovolí double[:] uvnitř @cython.locals()
ctypedef double[:,:] double_2D
ctypedef double[:,:,:] double_3D
ctypedef int[:] int_1D
ctypedef int[:,:] int_2D
ctypedef Puff[:,:] Puff_2D


#tady jeste neni nogil, takze muzu pouzivat pythoni metody
#
@cython.locals(pN = int, mC = int, rC = int, tt = int, t_meteo = int, i = int,  RESULTS = double_3D, j = int, STABS = int_2D,
	DISP_MODELS = double_3D, puff = Puff, sig_coe_mx_lay_he = double_2D, 
	models_ret = Puff_2D, ci_of_models = double_3D, dose_of_models = double_3D, k = int)
cpdef tuple parallel_puff(int j, double total_time_global, Puff[:,:] models, double[:, :] receptors,
    double doseA, double doseB, double doseMJU, double doseMJUaE, double doseCb, double dose_integration_time,
    int dose_sub_step_no, int n, double[:,:,:,:] METEO_FORECAST, bint obs_meteo_flag,
    double[:] METEO_OBS_WS, double[:] METEO_OBS_WD)
